// BINDInstallDlg.h : header file
//

#if !defined(AFX_BINDINSTALLDLG_H__61537817_39FC_11D3_A97A_00105A12BD65__INCLUDED_)
#define AFX_BINDINSTALLDLG_H__61537817_39FC_11D3_A97A_00105A12BD65__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CBINDInstallDlg dialog

class CBINDInstallDlg : public CDialog
{
// Construction
public:
	CBINDInstallDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CBINDInstallDlg)
	enum { IDD = IDD_BINDINSTALL_DIALOG };
	CString	m_targetDir;
	CString	m_version;
	BOOL	m_autoStart;
	BOOL	m_keepFiles;
	CString	m_current;
	BOOL	m_startOnInstall;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBINDInstallDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	void StartBINDService();
	void StopBINDService();

	void InstallTags();
	void UninstallTags();

	BOOL CreateDirs();
	void RemoveDirs(BOOL uninstall);

	BOOL CopyFiles();
	void DeleteFiles(BOOL uninstall);

	BOOL RegisterService();
	void UnregisterService(BOOL uninstall);

	BOOL RegisterMessages();
	void UnregisterMessages(BOOL uninstall);
	
	void FailedInstall();
	void SetItemStatus(UINT nID, BOOL bSuccess = TRUE);

// Implementation
protected:
	int MsgBox(int id,  ...);
	int MsgBox(int id, UINT type, ...);
	CString GetErrMessage();
	BOOL CheckBINDService();
	void SetCurrent(int id, ...);
	HICON m_hIcon;

	CString m_defaultDir;
	CString m_etcDir;
	CString m_binDir;

	// Generated message map functions
	//{{AFX_MSG(CBINDInstallDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnBrowse();
	afx_msg void OnChangeTargetdir();
	afx_msg void OnInstall();
	afx_msg void OnExit();
	afx_msg void OnUninstall();
	afx_msg void OnAutoStart();
	afx_msg void OnKeepFiles();
	afx_msg void OnStartOnInstall();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BINDINSTALLDLG_H__61537817_39FC_11D3_A97A_00105A12BD65__INCLUDED_)
